## slowmovideo 0.5

=== Makefile ===
.PHONY : tarball
.PHONY : release

# Creates a tarball when on a git repository. (git is required.)
tarball :
	@git archive master --format=tar |bzip2 >"slowmoVideo-sources-$(shell ./version.sh).tar.bz2"

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(slowmoVideo)

#set (CMAKE_BUILD_TYPE Release)
set(CMAKE_BUILD_TYPE Debug)

set(PROJECT_VERSION_MAJOR "0")
set(PROJECT_VERSION_MINOR "3")
set(PROJECT_VERSION_PATCH "1")
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

### Compiler options ###

if (APPLE)
# To compile with clang:
#set(CMAKE_CXX_COMPILER "clang++")
#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall --verbose")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall ")
#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -mtune=corei7")
else()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -g")
endif()

if(CMAKE_TOOLCHAIN_FILE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMXE")
  set(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS} -DMXE")
endif(CMAKE_TOOLCHAIN_FILE)


### CMake Configuration ###
option (ENABLE_TESTS "Build the unit tests" FALSE)
set(ADDITIONAL_LIBS "")
if(MSYS)
  message(STATUS "MSYS system detected.")
  include("${PROJECT_SOURCE_DIR}/cmake/MingwCrossEnv.cmake")
endif(MSYS)


### Find packages ###

set(CMAKE_MODULE_PATH
  ${slowmoVideo_SOURCE_DIR}/cmake
)

# Check if environment variable QTDIR is set.
# needed for Qt5
# Extra security for windows environment as well.
if (DEFINED ENV{QTDIR})
    set(CMAKE_PREFIX_PATH $ENV{QTDIR} ${CMAKE_PREFIX_PATH})
endif ()

set(DEST "bin")

include(cmake/macros.cmake)

# search for Qt4
if (NOT FORCE_QT4)
         find_package(Qt5Core QUIET)
         if (Qt5Core_FOUND) 
                 message(STATUS "Using qt5")
		 set(USE_QT TRUE)
		 # go on with other packages
		 find_package(Qt5 COMPONENTS Core Widgets Gui Xml Script)
		if (Qt5_POSITION_INDEPENDENT_CODE)
			set(CMAKE_POSITION_INDEPENDENT_CODE ON)
		endif(Qt5_POSITION_INDEPENDENT_CODE)
#		 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}
#		    ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")

		 include_directories(${Qt5Core_INCLUDES}) 
		 include_directories(${Qt5Widgets_INCLUDES}) 
		 include_directories(${Qt5Gui_INCLUDES}) 
		 include_directories(${Qt5Xml_INCLUDES}) 
		 include_directories(${Qt5Script_INCLUDES}) 

		 macro(qt_use_modules)
		    qt5_use_modules(${ARGN})
		 endmacro()
 
		 macro(qt_wrap_ui)
		     qt5_wrap_ui(${ARGN})
		 endmacro()
 
		 macro(qt_wrap_cpp)
		     qt5_wrap_cpp(${ARGN})
		 endmacro()
 
		 macro(qt_add_resources)
		     qt5_add_resources(${ARGN})
		 endmacro()
 
		 #find_package(Qt5LinguistTools REQUIRED)
		 macro(qt_add_translation)
		     qt5_add_translation(${ARGN})
		 endmacro()

		 macro(install_qt_executable)
			install_qt5_executable(${ARGN})
		 endmacro()
	 endif(Qt5Core_FOUND)
endif(NOT FORCE_QT4)

#old qt4 ...
if(NOT Qt5Core_FOUND) 

# should replace :
#SET(QT_USE_QTXML TRUE)
#SET(QT_USE_QTSCRIPT TRUE)
#find_package(Qt4)
#include(${QT_USE_FILE})
#include_directories(${QT_INCLUDES})

     message(STATUS "Could not find Qt5, searching for Qt4 instead...")
 
     set(NEEDED_QT4_COMPONENTS "QtCore" "QtXml" "QtGui" "QtScript") 
 
     find_package(Qt4 REQUIRED COMPONENTS ${NEEDED_QT4_COMPONENTS})

     macro(qt_use_modules)
 
     endmacro()
 
     macro(qt_wrap_ui)
         qt4_wrap_ui(${ARGN})
     endmacro()
 
     macro(qt_wrap_cpp)
         qt4_wrap_cpp(${ARGN})
     endmacro()
 
     macro(qt_add_resources)
         qt4_add_resources(${ARGN})
     endmacro()
 
     macro(qt_add_translation)
         qt4_add_translation(${ARGN})
     endmacro()
 
     macro(install_qt_executable)
         install_qt4_executable(${ARGN})
     endmacro()

     include(${QT_USE_FILE})
     add_definitions(${QT_DEFINITIONS})
 
     set(USE_QT TRUE)
endif()

message("Qt libraries found at : ${Qt5Gui_LIBRARIES} /  ${QT_LIBRARIES}" )

set (USE_QTKIT OFF CACHE BOOL "Build with the QTKit encoder")
set (USE_FFMPEG ON CACHE BOOL "Build with the FFMPEG encoder")
set (USE_DBUS OFF CACHE BOOL "Build with the DBUS notification support")

if(NOT MSYS)
	find_package(FFMPEG)
else(NOT MSYS)
    # Handled by MingwCrossEnv.cmake to avoid errors like:
    # libavformat.a(avisynth.o):avisynth.c:(.text+0x6b): undefined reference to `AVIStreamRelease@4'
endif(NOT MSYS)
# not here anymore
#include_directories(${FFMPEG_INCLUDE_DIR})
#include_directories("/usr/include/ffmpeg/")
#link_directories(${FFMPEG_LIBRARY_DIR})

if (APPLE AND USE_QTKIT)
	find_package(QTKIT)
	message(STATUS "QTKIT find at ${QTKIT_LIBRARY} ")
	set(ADDITIONAL_LIBS "-framework Cocoa -framework QTKit -framework QuartzCore -framework AppKit -framework OpenCL")
endif()
	
find_package(OpenCV)
include_directories(${OPENCV_INCLUDE_DIRS})

# for config.h
include_directories(${CMAKE_CURRENT_BINARY_DIR})



### Set up libraries ###
if(MSYS)
    set(EXTERNAL_LIBS ${FFMPEG_LIBRARIES} ${QT_LIBRARIES} ${OpenCV_LIBS_OPT} ${OpenCV_EXTRA_LIBS_OPT} ${ADDITIONAL_LIBS})
else(MSYS)
    set(EXTERNAL_LIBS ${QT_LIBRARIES} ${OpenCV_LIBS} ${ADDITIONAL_LIBS} ${FFMPEG_LIBRARIES})
endif(MSYS)


### Information output
set(BUILD_SLOWMO "NO")
#if(QT_LIBRARIES AND FFMPEG_FOUND)
if(USE_QT AND FFMPEG_FOUND)
set(BUILD_SLOWMO "YES")
#endif(QT_LIBRARIES AND FFMPEG_FOUND)
endif()
if(NOT FFMPEG_SWSCALE_FOUND)
  if(CMAKE_TOOLCHAIN_FILE)

  else(CMAKE_TOOLCHAIN_FILE)
  set(BUILD_SLOWMO "NO")
  endif(CMAKE_TOOLCHAIN_FILE)
endif(NOT FFMPEG_SWSCALE_FOUND)





## Include projects to build ##

include_directories(slowmoVideo/tr)
add_subdirectory(slowmoVideo/lib)
add_subdirectory(slowmoVideo/libgui)
add_subdirectory(slowmoVideo/project)
add_subdirectory(slowmoVideo/slowmoCLI)
add_subdirectory(slowmoVideo/slowmoUI)
add_subdirectory(slowmoVideo/slowmoFlowEdit)
add_subdirectory(slowmoVideo/slowmoInfo)
add_subdirectory(slowmoVideo/slowmoRenderer)
add_subdirectory(slowmoVideo/visualizeFlow)
if(ENABLE_TESTS)
SET(QT_USE_QTTEST TRUE)
add_subdirectory(slowmoVideo/test)
add_subdirectory(slowmoVideo/unittests)
endif(ENABLE_TESTS)

##### SV END #####





##### V3D START #####

if(WIN32)
set(GLUT_ROOT_PATH ${PROJECT_SOURCE_DIR}/libs/)
endif(WIN32)

find_package(OpenGL)
find_package(GLEW)
find_package(GLUT)
find_package(JPEG)
find_package(PNG)
find_package(ZLIB)
find_package(X11)

# Windows: Try to find libraries that could not be found manually in the libs/ directory.
if(WIN32)
	if(NOT ZLIB_FOUND)
		FIND_PATH(ZLIB_INCLUDE_DIR zlib.h
			PATHS ${PROJECT_SOURCE_DIR}/libs/include
		)
		find_library(ZLIB_LIBRARY NAMES zlib PATHS ${PROJECT_SOURCE_DIR}/libs/lib)
		if(ZLIB_INCLUDE_DIR AND ZLIB_LIBRARY)
			set(ZLIB_FOUND TRUE)
		endif(ZLIB_INCLUDE_DIR AND ZLIB_LIBRARY)
		message(STATUS "Manual search for zlib: ${ZLIB_LIBRARY} in ${ZLIB_INCLUDE_DIR}")
	endif(NOT ZLIB_FOUND)
	
	if(NOT PNG_FOUND)
		find_path(PNG_INCLUDE_DIR png.h PATHS ${PROJECT_SOURCE_DIR}/libs/include)
		find_library(PNG_LIBRARIES libpng PATHS ${PROJECT_SOURCE_DIR}/libs/lib)
		if(PNG_INCLUDE_DIR AND PNG_LIBRARIES)
			set(PNG_FOUND TRUE)
		endif(PNG_INCLUDE_DIR AND PNG_LIBRARIES)
		message(STATUS "Manual search for png: ${PNG_LIBRARIES} in ${PNG_INCLUDE_DIR}")
	endif(NOT PNG_FOUND)
	
	if(NOT GLUT_FOUND)
		find_path(GLUT_LIBRARY_DIR NAMES GL/glut.h PATHS ${PROJECT_SOURCE_DIR}/libs/include)
		find_library(GLUT_LIBRARIES glut32 PATHS ${PROJECT_SOURCE_DIR}/libs/lib)
		if(GLUT_LIBRARY_DIR AND GLUT_LIBRARIES)
			set(GLUT_FOUND TRUE)
		endif(GLUT_LIBRARY_DIR AND GLUT_LIBRARIES)
		message(STATUS "Manual search for GLUT: ${GLUT_LIBRARIES} in ${GLUT_LIBRARY_DIR}")
	endif(NOT GLUT_FOUND)

	if(NOT JPEG_FOUND)
		FIND_PATH(JPEG_INCLUDE_DIR jpeglib.h PATHS ${PROJECT_SOURCE_DIR}/libs/include)

		SET(JPEG_NAMES ${JPEG_NAMES} jpeg)
		FIND_LIBRARY(JPEG_LIBRARY NAMES ${JPEG_NAMES} PATHS ${PROJECT_SOURCE_DIR}/libs/lib)
		if(JPEG_INCLUDE_DIR AND JPEG_LIBRARY)
			set(JPEG_FOUND TRUE)
		endif(JPEG_INCLUDE_DIR AND JPEG_LIBRARY)
		message(STATUS "Manual search for JPEG: ${JPEG_LIBRARY} in ${JPEG_INCLUDE_DIR}")
	endif(NOT JPEG_FOUND)
endif(WIN32)


set(BUILD_FLOW_BUILDER "NO")
if(OPENGL_FOUND AND GLUT_FOUND AND GLEW_FOUND AND JPEG_FOUND AND PNG_FOUND)
	set(BUILD_FLOW_BUILDER "YES")
endif(OPENGL_FOUND AND GLUT_FOUND AND GLEW_FOUND AND JPEG_FOUND AND PNG_FOUND)

set(INCLUDE_SOURCE "YES")
if(DISABLE_INCLUDE_SOURCE)
	set(INCLUDE_SOURCE "NO")
add_definitions(-DDISABLE_INCLUDE_SOURCE)
endif(DISABLE_INCLUDE_SOURCE)


if (BUILD_FLOW_BUILDER)
    include_directories(${OPENGL_INCLUDE_DIR})
    include_directories(${GLUT_INCLUDE_DIR})
    include_directories(${GLEW_INCLUDE_DIR})
    include_directories(${JPEG_INCLUDE_DIR})
    include_directories(${ZLIB_INCLUDE_DIR})
    include_directories(${PNG_INCLUDE_DIR})


    set (V3D_DIR ${CMAKE_CURRENT_SOURCE_DIR}/V3D)
    set (V3D_INCLUDE_DIRS ${V3D_DIR}/.)

    include (V3D/Config/v3d_macros.cmake)
    include_directories(${V3D_INCLUDE_DIRS} ${EXTRA_INC_DIRS})

    add_definitions(-DDISABLE_REDEFINITIONS)
    #--------------------------------------------------
    enable_feature (V3DLIB_ENABLE_LIBJPEG)
    enable_feature (V3DLIB_ENABLE_LIBPNG)
    enable_feature_libraries (V3DLIB_ENABLE_LIBJPEG ${JPEG_LIBRARIES})
    enable_feature_libraries (V3DLIB_ENABLE_LIBPNG ${PNG_LIBRARIES})

    enable_feature (V3DLIB_ENABLE_GPGPU)
    enable_feature_libraries (V3DLIB_ENABLE_GPGPU ${OPENGL_LIBRARIES})
    enable_feature_libraries (V3DLIB_ENABLE_GPGPU ${GLEW_LIBRARIES})
    enable_feature_libraries (V3DLIB_ENABLE_GPGPU ${GLUT_glut_LIBRARY})
    #--------------------------------------------------


    include_directories(V3D/Config)

    set (GL_SRC
        V3D/GL/glsl_shaders.cpp
        V3D/GL/v3d_gpubase.cpp
        V3D/GL/v3d_gpuflow.cpp
        V3D/GL/v3d_gpucolorflow.cpp
        V3D/GL/v3d_gpupyramid.cpp
    )

    set (ALL_SRC
        ${GL_SRC}
        V3D/Config/config.h
        
        V3D/Base/v3d_image.cpp
        V3D/Base/v3d_imageprocessing.h
        V3D/Base/v3d_exception.h
        V3D/Base/v3d_timer.h
        V3D/Base/v3d_serialization.h
        V3D/Base/v3d_utilities.h
        V3D/Math/v3d_linear.h
        V3D/Math/v3d_linearbase.h
    )

    add_library(V3D ${ALL_SRC})
    target_link_libraries(V3D ${GLEW_LIBRARIES} X11)
    #install(TARGETS V3D DESTINATION lib)
    add_subdirectory(V3D/Apps)
endif (BUILD_FLOW_BUILDER)

##### V3D END #####





message("")
message("======================V3D============================")
message("* (info) Installation prefix: ${CMAKE_INSTALL_PREFIX}.")
message("         (Can be adjusted with -DCMAKE_INSTALL_PREFIX=your_path.  Default: ${SV_INST_DIR}.)")
message("* (info) Shaders will be included in the binary: ${INCLUDE_SOURCE}")
if(INCLUDE_SOURCE)
	message("         (Can be disabled with the cmake flag -DDISABLE_INCLUDE_SOURCE)")
endif(INCLUDE_SOURCE)


if(NOT OPENGL_FOUND)
	message("* OpenGL could not be found.")
else(NOT OPENGL_FOUND)
	message("* (ok) OpenGL found in ${OPENGL_INCLUDE_DIR}: ${OPENGL_LIBRARIES}")
endif(NOT OPENGL_FOUND)

if(NOT GLUT_FOUND)
	message("* GLUT could not be found.")
else(NOT GLUT_FOUND)
	message("* (ok) GLUT found in ${GLUT_INCLUDE_DIR}: ${GLUT_LIBRARIES}")
endif(NOT GLUT_FOUND)

if(NOT GLEW_FOUND)
	message("* GLEW could not be found.")
else(NOT GLEW_FOUND)
	message("* (ok) GLEW found at ${GLEW_INCLUDE_DIR}")
endif(NOT GLEW_FOUND)

if(NOT JPEG_FOUND)
	message("* JPEG libraries could not be found.")
else(NOT JPEG_FOUND)
	message("* (ok) JPEG libraries found at ${JPEG_INCLUDE_DIR}: ${JPEG_LIBRARIES}")
endif(NOT JPEG_FOUND)

if(NOT PNG_FOUND)
	message("* PNG libraries could not be found.")
else(NOT PNG_FOUND)
	message("* (ok) PNG libraries found at ${PNG_INCLUDE_DIR}")
endif(NOT PNG_FOUND)

message("* V3D will be built:                        ---${BUILD_FLOW_BUILDER}---")


message("==================slowmoVideo========================")
message("* (info) slowmoVideo installation goes to ${CMAKE_INSTALL_PREFIX}.")
message("         (Can be adjusted with -DCMAKE_INSTALL_PREFIX=your_path. Default is ${SV_INST_DIR}.)")
#if(NOT QT_LIBRARIES)
if (NOT USE_QT)
    message("QT5 nor Qt4 libraries could not be found.")
#endif(NOT QT_LIBRARIES)
endif(NOT USE_QT)
if(NOT FFMPEG_FOUND)
    message("x ffmpeg libraries could not be found.")
else(NOT FFMPEG_FOUND)
    message("* (ok) ffmpeg found at ${FFMPEG_LIBRARY_DIR}")

=== src/slowmoVideo/slowmoUI/CMakeLists.txt ===

# Building Qt+UI apps:
# http://www.qtcentre.org/wiki/index.php?title=Compiling_Qt4_apps_with_CMake
# http://www.cmake.org/pipermail/cmake/2008-September/023908.html



include_directories(${slowmoVideo_SOURCE_DIR})

set(SRCS
  main.cpp
  mainwindow.cpp
  canvas.cpp
  canvasTools.cpp
  flowEditCanvas.cpp
  frameMonitor.cpp
  renderPreview.cpp
  dialogues/newProjectDialog.cpp
  dialogues/preferencesDialog.cpp
  dialogues/projectPreferencesDialog.cpp
  dialogues/progressDialog.cpp
  dialogues/renderingDialog.cpp
  dialogues/shutterFunctionDialog.cpp
  dialogues/shutterFunctionFrame.cpp
  dialogues/flowExaminer.cpp
  dialogues/tagAddDialog.cpp
  dialogues/aboutDialog.cpp
        notificator.cpp
)

# notification
if (APPLE)
set(SRCS
        ${SRCS}
        macnotificationhandler.mm
)
endif()

set(SRCS_UI
  mainwindow.ui
  canvas.ui
  frameMonitor.ui
  renderPreview.ui
  flowEditCanvas.ui
  dialogues/newProjectDialog.ui
  dialogues/preferencesDialog.ui
  dialogues/projectPreferencesDialog.ui
  dialogues/progressDialog.ui
  dialogues/renderingDialog.ui
  dialogues/shutterFunctionDialog.ui
  dialogues/flowExaminer.ui
  dialogues/tagAddDialog.ui
  dialogues/aboutDialog.ui
)

set(SRCS_MOC
  mainwindow.h
  canvas.h
  frameMonitor.h
  flowEditCanvas.h
  renderPreview.h
  dialogues/newProjectDialog.h
  dialogues/preferencesDialog.h
  dialogues/projectPreferencesDialog.h
  dialogues/progressDialog.h
  dialogues/renderingDialog.h
  dialogues/shutterFunctionDialog.h
  dialogues/shutterFunctionFrame.h
  dialogues/flowExaminer.h
  dialogues/tagAddDialog.h
  dialogues/aboutDialog.h
        notificator.h
)

# notification
if (APPLE)
set(SRCS_MOC
        ${SRCS_MOC}
        macnotificationhandler.h
)
endif()

if(APPLE)
	set(BUNDLE "slowmoUI")
	set(ICONS_DIR "${${PROJECT_NAME}_SOURCE_DIR}/slowmoVideo/slowmoUI/res")
        message( "OS X build" )
        set(MACOSX_BUNDLE_INFO_STRING "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_BUNDLE_VERSION "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_LONG_VERSION_STRING "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_COPYRIGHT "${PROJECT_COPYRIGHT_YEAR} ${PROJECT_VENDOR}")
        set(MACOSX_BUNDLE_ICON_FILE "slowmoUI.icns")
        set(MACOSX_BUNDLE_GUI_IDENTIFIER "${PROJECT_DOMAIN_SECOND}.${PROJECT_DOMAIN_FIRST}")
        set(MACOSX_BUNDLE_BUNDLE_NAME "${BUNDLE}")

        set(MACOSX_BUNDLE_RESOURCES "${CMAKE_CURRENT_BINARY_DIR}/${BUNDLE}.app/Contents/Resources")
        set(MACOSX_BUNDLE_ICON "${ICONS_DIR}/${MACOSX_BUNDLE_ICON_FILE}")
	SET_SOURCE_FILES_PROPERTIES(
	   ${MACOSX_BUNDLE_ICON} 
	    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
        message(STATUS "slowmoUI Bundle will be : ${MACOSX_BUNDLE} ")

	set( SRCS ${SRCS} ${MACOSX_BUNDLE_ICON} )

endif()

# Without these includes the promoted widgets fail to compile
# since the headers are not found. (For whatever reason.)
include_directories(dialogues)
include_directories(.)
include_directories(..)

# Embed images in the binary
set(SRC_RES resources.qrc)
qt_add_resources(RES_OUT ${SRC_RES})

# Generate header files from the .ui files
qt_wrap_ui(UI_H_OUT ${SRCS_UI})
qt_wrap_cpp(MOC_OUT ${SRCS_MOC})

# Include the generated header files
include_directories(${CMAKE_BINARY_DIR}/slowmoVideo/slowmoUI)


link_directories(${FFMPEG_LIBRARY_DIR})
add_executable(slowmoUI WIN32 MACOSX_BUNDLE ${SRCS} ${MOC_OUT} ${UI_H_OUT} ${RES_OUT})
qt_use_modules(slowmoUI Script Widgets Concurrent Gui  Core )
target_link_libraries(slowmoUI sVproj sVvis sVgui )

if(APPLE)
  configure_file(${CMAKE_SOURCE_DIR}/slowmoVideo/slowmoUI/res/Info.plist.cmake ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  set_target_properties(${PROGNAME} PROPERTIES
                        MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  #ADD_CUSTOM_COMMAND(TARGET slowmoUI
  #  POST_BUILD
  #  COMMAND cp Info.plist slowmoUI.app/Contents/Info.plist
  #  COMMENT "Updating Info.plist"
  #  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )

endif()

#install(TARGETS ${slowmoUI}
#        BUNDLE DESTINATION . COMPONENT Runtime
#        RUNTIME DESTINATION ${BIN_INSTALL_DIR} COMPONENT Runtime)

if (UNIX)
# create desktop file for KDE/Gnome
# desktop file section
	file( WRITE "${PROJECT_BINARY_DIR}/slowmoUI.desktop"
"#!/usr/bin/env xdg-open
[Desktop Entry]
Type=Application
Comment=Slow Motion Video
Exec=${CMAKE_INSTALL_PREFIX}/bin/slowmoUI
GenericName=slowmoVideo
Icon=${CMAKE_INSTALL_PREFIX}/share/icons/AppIcon.png
MimeType=
Name=slowmoUI
Terminal=false
Categories=Qt;AudioVideo;Video;\n")

	#install ( FILES icons/slowmoUI.png DESTINATION share/icons )
	install ( FILES res/AppIcon.png DESTINATION share/icons )
	install ( FILES ${PROJECT_BINARY_DIR}/slowmoUI.desktop DESTINATION share/applications
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)
endif()

if (Qt5Core_FOUND)
	include(DeployQt5) # 2.8.7 or later
else()
	include(DeployQt4) # 2.8.7 or later
endif()

#set( PLUGINS "qjpeg;qtiff" )
set( PLUGINS qjpeg )
if (APPLE)
       install(TARGETS slowmoUI DESTINATION ".")
       install_qt_executable(slowmoUI.app "${PLUGINS}"  )
elseif(WIN32)
       install(TARGETS slowmoUI DESTINATION ".")
       install_qt_executable(slowmoUI.exe "${PLUGINS}"  )
else()
       install(TARGETS slowmoUI DESTINATION ${DEST})
#       install_qt_executable(slowmoUI "${PLUGINS}"  )
endif()

=== src/slowmoVideo/test/CMakeLists.txt ===
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
message(STATUS "CXX flags: ${CMAKE_CXX_FLAGS}")

set(SRCS
    test.cpp
)

include_directories(${FFMPEG_INCLUDE_PATHS})
add_executable(Test ${SRCS})
target_link_libraries(Test sVproj ${EXTERNAL_LIBS})

add_executable(encodeTest encodeTest.c)
target_link_libraries(encodeTest sVencode ${EXTERNAL_LIBS})

add_executable(encodeFramesTest ffmpegTestEncodeFrames.cpp)
message(STATUS "Additional libraries: ${ADDITIONAL_LIBS}")
target_link_libraries(encodeFramesTest sVencode ${EXTERNAL_LIBS})

add_executable(AvconvInfo testAvconvInfo.cpp)
target_link_libraries(AvconvInfo sVinfo ${EXTERNAL_LIBS})

install(TARGETS Test DESTINATION bin)

=== src/slowmoVideo/unittests/CMakeLists.txt ===

set(SRCS
    testFlowRW_sV.cpp
    testFlowField_sV.cpp
    testVector_sV.cpp
    testIntMatrix_sV.cpp
    testXmlProjectRW_sV.cpp
    testDefs_sV.cpp
    testShutterFunction_sV.cpp
    testProject_sV.cpp
    testNodeList_sV.cpp
    testAll.cpp
)
set(SRCS_MOC
    testFlowRW_sV.h
    testFlowField_sV.h
    testVector_sV.h
    testIntMatrix_sV.h
    testDefs_sV.h
    testShutterFunction_sV.h
    testXmlProjectRW_sV.h
    testNodeList_sV.h
    testProject_sV.h
)

qt_wrap_cpp(MOC_OUT ${SRCS_MOC})

include_directories(${FFMPEG_INCLUDE_PATHS})
add_executable(UnitTests ${SRCS} ${MOC_OUT})
target_link_libraries(UnitTests sVproj ${EXTERNAL_LIBS})

=== debian/changelog ===
slowmovideo (0.5-1mx150+1) mx; urgency=medium

  * Rebuild for MX-15.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Mon, 18 Apr 2016 19:42:37 -0700

slowmovideo (0.5-1~getdeb1) wily; urgency=medium

  * New upstream version

 -- Christoph Korn <christoph.korn@getdeb.net>  Sat, 06 Feb 2016 23:09:46 +0100

slowmovideo (0.4+git160113-1~getdeb1) wily; urgency=medium

  * New upstream version

 -- Christoph Korn <christoph.korn@getdeb.net>  Tue, 12 Jan 2016 21:33:48 +0100

slowmovideo (0.3.3-1~saucy1) saucy; urgency=low

  * Initial release for saucy

 -- Benoit Rousselle <brousselle@gmail.com>  Mon, 21 Oct 2013 10:16:03 +0200

slowmovideo (0.3.3-1~raring1) raring; urgency=low

  * FlowBuilder (GPU computation) was missing from package: this is now fixed

 -- Benoit Rousselle <brousselle@gmail.com>  Thu, 12 Sep 2013 14:32:21 +0200

slowmovideo (0.3.3-1~precise1) precise; urgency=low

  * fixes an issue in the dependencies

 -- Benoit Rousselle <brousselle@gmail.com>  Wed, 11 Sep 2013 14:42:57 +0200

slowmovideo (0.3.2-1~precise1) precise; urgency=low

  * previous try to add GPU computation failed. This should be fixed now thanks to simpleCmake branch from Simon.

 -- Benoit Rousselle <brousselle@gmail.com>  Tue, 10 Sep 2013 10:51:39 +0200

slowmovideo (0.3.1-6~precise1) precise; urgency=low

  * FlowBuilder (GPU computation) was missing from package: this is now fixed

 -- Benoit Rousselle <brousselle@gmail.com>  Mon, 10 Jun 2013 13:28:25 +0200

slowmovideo (0.3.1-5~precise1) precise; urgency=low

  * Fixing bad release version for precise

 -- Benoit Rousselle <brousselle@gmail.com>  Tue, 07 May 2013 08:30:31 +0200

slowmovideo (0.3.1-5~raring1) raring; urgency=low

  * Initial release for raring

 -- Benoit Rousselle <brousselle@gmail.com>  Tue, 07 May 2013 08:29:14 +0200

slowmovideo (0.3.1-4~raring1) precise; urgency=low

  * Initial release for raring

 -- Benoit Rousselle <brousselle@gmail.com>  Tue, 07 May 2013 08:15:32 +0200

slowmovideo (0.3.1-4~quantal1) quantal; urgency=low

  * Initial release for quantal

 -- Benoit Rousselle <brousselle@gmail.com>  Thu, 18 Apr 2013 14:36:33 +0200

slowmovideo (0.3.1-3) precise; urgency=low

  * add menu entry

 -- Benoit Rousselle <brousselle@gmail.com>  Wed, 17 Apr 2013 10:24:05 +0200

slowmovideo (0.3.1-2) precise; urgency=low

  * Initial release 

 -- Benoit Rousselle <brousselle@gmail.com>  Tue, 26 Mar 2013 09:43:19 +0100

=== debian/control ===
Source: slowmovideo
Section: graphics
Priority: optional
Maintainer: Steven Pusser (Stevo) <maintainer@mepiscommunity.org>
Bugs: mailto: maintainer@mepiscommunity.org
XSBC-Original-Maintainer: GetDeb Package Ninjas <package.ninjas@getdeb.net>
Build-Depends: debhelper (>= 9),
               cmake,
               libavformat-dev,
               libopencv-dev,
               qtbase5-dev,
               qt5-default,
               qtscript5-dev,
               freeglut3-dev,
               libglew1.6-dev,
               libsdl1.2-dev
Standards-Version: 3.9.6
Homepage: http://slowmovideo.granjow.net

Package: slowmovideo
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ffmpeg
Description: slow-motion videos from your footage
 slowmoVideo is an OpenSource program that creates slow-motion videos 
 from your footage.
 But it does not simply make your videos play at 0.01× speed.
 You can smoothly slow down and speed up your footage,
 optionally with motion blur.

=== debian/rules ===
#!/usr/bin/make -f

export DH_OPTIONS
export DH_VERBOSE=1
export QT_SELECT=qt5
%:
	dh "$@" -Dsrc --buildsystem=cmake --parallel

=== debian/watch ===
version=3
opts="dversionmangle=s/\+git\d+//" \
https://github.com/slowmoVideo/slowmoVideo/releases \
    (?:.*/)?v([\d\.]+)\.tar\.gz

## slowmovideo 0.5%2Bgit20190116

=== src/slowmoVideo/test/CMakeLists.txt ===
set(SRCS
    test.cpp
)

include_directories(${FFMPEG_INCLUDE_PATHS})
add_executable(Test ${SRCS})
target_link_libraries(Test sVproj ${EXTERNAL_LIBS})

#add_executable(encodeTest encodeTest.c)
#target_link_libraries(encodeTest sVencode ${EXTERNAL_LIBS})

#add_executable(encodeFramesTest ffmpegTestEncodeFrames.cpp)
#message(STATUS "Additional libraries: ${ADDITIONAL_LIBS}")
#target_link_libraries(encodeFramesTest sVencode  ${EXTERNAL_LIBS})

add_executable(AvconvInfo testAvconvInfo.cpp)
target_link_libraries(AvconvInfo sVinfo ${EXTERNAL_LIBS})

install(TARGETS Test DESTINATION bin)
